package xyz.lychee.lagfixer.libs.adventure.resource;

import java.util.UUID;
import java.util.function.BiConsumer;
import xyz.lychee.lagfixer.libs.adventure.audience.Audience;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

@FunctionalInterface
public interface ResourcePackCallback {
   static @NotNull ResourcePackCallback noOp() {
      return ResourcePackCallbacks.NO_OP;
   }

   static @NotNull ResourcePackCallback onTerminal(final @NotNull BiConsumer<UUID, Audience> success, final @NotNull BiConsumer<UUID, Audience> failure) {
      return (uuid, status, audience) -> {
         if (status == ResourcePackStatus.SUCCESSFULLY_LOADED) {
            success.accept(uuid, audience);
         } else if (!status.intermediate()) {
            failure.accept(uuid, audience);
         }

      };
   }

   void packEventReceived(final @NotNull UUID uuid, final @NotNull ResourcePackStatus status, final @NotNull Audience audience);
}
